package CoswayUtil;

import org.bukkit.Instrument;
import org.bukkit.Note;
import org.bukkit.Note.Tone;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class NoteStudio {
    private static CoswayUtil plugin;

    public static void init(CoswayUtil pluginInstance) {
        plugin = pluginInstance;
    }

    public static void playNoteBlockSong(Player player) {
        if (plugin == null) {
            throw new IllegalStateException("NoteStudio has not been initialized!");
        }

        Note[] songNotes = {
                Note.natural(0, Tone.C), Note.natural(0, Tone.E), Note.natural(0, Tone.G),
                Note.natural(1, Tone.C), Note.natural(1, Tone.G), Note.natural(1, Tone.E),
                Note.natural(2, Tone.C), Note.natural(2, Tone.D), Note.natural(2, Tone.E)
        };

        new BukkitRunnable() {
            int index = 0;

            @Override
            public void run() {
                if (index >= songNotes.length) {
                    cancel();
                    return;
                }

                // Play the note for the player
                player.playNote(player.getLocation(), Instrument.PIANO, songNotes[index]);

                // Also play a sound so everyone nearby can hear it
                player.getWorld().playSound(player.getLocation(), Sound.BLOCK_NOTE_BLOCK_HARP, 1, songNotes[index].getId() / 24.0f);

                index++;
            }
        }.runTaskTimer(plugin, 0, 10); // Plays one note every 10 ticks (0.5s)
    }
}
